<?php
// $Id: rssc_get_handler.php,v 1.1.1.1 2006/01/03 05:06:07 ohwada Exp $

//=========================================================
// RSS Center Module
// 2006-01-01 K.OHWADA
//=========================================================

// --- rssc_get_handler begin ---
if( !function_exists( 'rssc_get_handler' ) ) 
{

function &rssc_get_handler($name=null, $module_dir=null)
{
	static $handlers;

// if $module_dir is not specified
	if (!isset($module_dir)) 
	{
//if a module is loaded
		if ( isset($GLOBALS['xoopsModule']) && is_object($GLOBALS['xoopsModule']) )
		{
			$module_dir = $GLOBALS['xoopsModule']->getVar('dirname');
		}
		else 
		{
			trigger_error('No Module is loaded', E_USER_ERROR);
		}
	}
	else 
	{
		$module_dir = trim($module_dir);
	}

	$name = (!isset($name)) ? $module_dir : trim($name);

	if (!isset($handlers[$module_dir][$name])) 
	{
		$class = 'rssc_'.$name.'_handler';
		$file  = XOOPS_ROOT_PATH.'/modules/'.$module_dir.'/class/'.$class.'.php';

		if ( file_exists($file) )
		{
			include_once $file;
		}

		if ( class_exists($class) ) 
		{
			$handlers[$module_dir][$name] = new $class( $module_dir );
		}
	}

	if ( isset($handlers[$module_dir][$name]) ) 
	{
		return $handlers[$module_dir][$name];
	}
	else
	{
		trigger_error('Handler does not exist<br />Module: '.$module_dir.'<br />Name: '.$name, E_USER_ERROR);
	}

	return false;
}

}
// --- rssc_get_handler end ---


?>